datablock DebrisData(toolboxPart2Debris)
{

	shapeFile = "./toolboxgear.dts";
	lifetime = 2.8;
	spinSpeed			= 1200.0;
	minSpinSpeed = -3600.0;
	maxSpinSpeed = 3600.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};

datablock DebrisData(toolboxPart3Debris)
{

	shapeFile = "./toolboxPart2.dts";
	lifetime = 4.0;
	spinSpeed			= 200.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 3;
};

datablock DebrisData(toolboxPart4Debris)
{

	shapeFile = "./toolboxPart1.dts";
	lifetime = 4.0;
	spinSpeed			= 200.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 4;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(toolboxOpenExplosionParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 2200;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.8 0.8 0.6 0.3";
	colors[1]			= "0.8 0.8 0.6 0.0";
	sizes[0]			= 6.25;
	sizes[1]			= 8.25;

	useInvAlpha = true;
};

datablock ParticleEmitterData(toolboxOpenExplosionEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 1.0;
	ejectionOffset  	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "toolboxOpenExplosionParticle";
};

datablock ParticleData(toolboxOpenChunksParticle)
{
	dragCoefficient			= 1;
	gravityCoefficient		= 6;
	inheritedVelFactor		= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 700;
	lifetimeVarianceMS		= 100;
	textureName				= "base/data/particles/nut";
	spinSpeed				= 790.0;
	spinRandomMin			= -790.0;
	spinRandomMax			= 790.0;
	colors[0]				= "0.4 0.2 0.0 0.6";
	colors[1]				= "0.4 0.2 0.0 0.0";
	sizes[0]				= 0.7;
	sizes[1]				= 0.6;

	useInvAlpha				= false;
};

datablock ParticleEmitterData(toolboxOpenChunksEmitter)
{
	lifeTimeMS			= 100;
	ejectionPeriodMS	= 6;
	periodVarianceMS	= 0;
	ejectionVelocity	= 12;
	velocityVariance	= 12.0;
	ejectionOffset		= 1.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "toolboxOpenChunksParticle";
};

datablock ParticleData(toolboxOpenSprayParticle)
{
	dragCoefficient			= 0.2;
	gravityCoefficient		= 5;
	inheritedVelFactor		= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 1000;
	lifetimeVarianceMS		= 200;
	textureName				= "base/data/particles/chunk";
	spinSpeed				= 900.0;
	spinRandomMin			= -900.0;
	spinRandomMax			= 900.0;
	colors[0]				= "0.27 0.1 0.0 1";
	colors[1]				= "0.27 0.1 0.0 1";
	colors[2]				= "0.27 0.1 0.0 0";
	sizes[0]				= 0.8;
	sizes[1]				= 0.8;
	sizes[2]				= 0.0;
	useInvAlpha				= false;
};

datablock ParticleEmitterData(toolboxOpenSprayEmitter)
{
	lifeTimeMS			= 100;
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 18;
	velocityVariance	= 18.0;
	ejectionOffset		= 1.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "toolboxOpenSprayParticle";
};

//explosion
//////////////////////////////////////////

datablock ExplosionData(toolboxOpenDebris1Explosion)
{
   particleEmitter = toolboxOpenChunksEmitter;
   particleDensity = 4;
   particleRadius = 0.2;

   debris = toolboxPart2Debris;
   debrisNum = 8;
   debrisNumVariance = 6;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 12;
   debrisVelocityVariance = 6;
};

datablock ExplosionData(toolboxOpenDebris2Explosion)
{
   debris = toolboxPart3Debris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 16;
   debrisVelocityVariance = 6;
};

datablock ExplosionData(toolboxExplosionExplosion)
{

   explosionShape = "";

   lifeTimeMS = 150;

   debris = toolboxPart4Debris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 16;
   debrisVelocityVariance = 6;

   particleEmitter = toolboxOpenExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = toolboxOpenSprayEmitter;
   emitter[1] = toolboxOpenStreakEmitter;
   emitter[2] = toolboxOpenChunksEmitter;

   subExplosion[0] = toolboxOpenDebris1Explosion;
   subExplosion[1] = toolboxOpenDebris2Explosion;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.1;
   camShakeRadius = 20.0;
};

datablock ExplosionData(toolboxExplosion)
{

   explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = toolboxOpenExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = toolboxOpenSprayEmitter;
   emitter[1] = toolboxOpenStreakEmitter;
   emitter[2] = toolboxOpenChunksEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.1;
   camShakeRadius = 20.0;
};

datablock ProjectileData(toolboxExplosionProjectile)
{
	uiname							= "";

	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= toolboxExplosionExplosion;

};

datablock ProjectileData(toolboxExplosion2Projectile)
{
	uiname							= "";

	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= toolboxExplosion;

};

datablock ParticleData(toolboxBBBeepParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/thinring";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "1 1 1 0.8";
	colors[1]			= "1 1 1 0.0";
	sizes[0]			= 15.25;
	sizes[1]			= 17.25;

	useInvAlpha = true;
};

datablock ParticleEmitterData(toolboxBBBeepEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 1.0;
	ejectionOffset  	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "toolboxBBBeepParticle";
};

datablock ExplosionData(sentryExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = toolboxBBBeepEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.1;
   camShakeRadius = 20.0;
};