//$sentryImage_[KITNAME]_[LEVEL]
$sentryImage_Rocket_1 = "sentryCannonImage";
$sentryImage_Rocket_2 = "sentryRocketImage";
$sentryImage_Rocket_3 = "sentryBigRocketImage";

$sentryUpgradeThreshold_Rocket_2 = 400;
$sentryUpgradeThreshold_Rocket_3 = 400;

exec("add-ons/weapon_gun/server.cs");

datablock AudioProfile(sentryRocketSound)
{
   filename    = "./sentryRocket.wav";
   description = AudioClosest3d;
   preload = true;
};

//=============================================================================

datablock ParticleData(sentryRocketExplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.9 0.5 0.0 0.9";
   colors[1]     = "0.0 0.0 0.0 0.9";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 8.0;
   sizes[1]      = 25.0;
   sizes[2]      = 19.0;

   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 1.0;

   useInvAlpha = true;
};

datablock ParticleEmitterData(sentryRocketExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sentryRocketExplosionParticle";
};

datablock ParticleData(sentryRocketExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 40;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 0.5 0.0 0.5";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 14;
   sizes[1]      = 21;

   useInvAlpha = false;
};
datablock ParticleEmitterData(sentryRocketExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sentryRocketExplosionRingParticle";
};


datablock ParticleData(sentryRocketExplosionChunkParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 3;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1400;
   lifetimeVarianceMS   = 1300;
   textureName          = "base/data/particles/chunk";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0.1 0.1 0.1 0.5";
   colors[1]     = "0.0 0.0 0.0 0.5";
   sizes[0]      = 0.7;
   sizes[1]      = 0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(sentryRocketExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 25;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sentryRocketExplosionChunkParticle";
};

datablock ExplosionData(sentryRocketExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = sentryRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = sentryRocketExplosionRingEmitter;
   emitter[1] = sentryRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 7;
   radiusDamage = 50;

   impulseRadius = 6;
   impulseForce = 1000;
};

///////////////////////////////

datablock ParticleData(sentryRocket2ExplosionParticle : sentryRocketExplosionParticle)
{
   sizes[0]      = 8.0;
   sizes[1]      = 25.0;
};

datablock ParticleEmitterData(sentryRocket2ExplosionEmitter : sentryRocketExplosionEmitter)
{
   particles = "sentryRocket2ExplosionParticle";
};

datablock ExplosionData(sentryRocket2Explosion : sentryRocketExplosion)
{
   damageRadius = 9;
   radiusDamage = 80;
   particleEmitter = sentryRocket2ExplosionEmitter;
};

///////////////////////////////

datablock ParticleData(sentryRocket3ExplosionParticle : sentryRocketExplosionParticle)
{
   sizes[0]      = 8.0;
   sizes[1]      = 38.0;
};

datablock ParticleEmitterData(sentryRocket3ExplosionEmitter : sentryRocketExplosionEmitter)
{
   particles = "sentryRocket3ExplosionParticle";
};

datablock ExplosionData(sentryRocket3Explosion : sentryRocketExplosion)
{
   damageRadius = 12;
   radiusDamage = 100;
   particleEmitter = sentryRocket3ExplosionEmitter;
};

//=============================================================================

datablock ParticleData(sentryrocketTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 405;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.45;
	sizes[1]      = 1.85;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(sentryrocketTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sentryrocketTrailParticle";
};

//LEVEL 1======================================================================
//=============================================================================
//=============================================================================

//projectile
AddDamageType("SentryGunCannon",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket1> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket1> %1',0.75,1);

datablock ProjectileData(sentryCannonProjectile)
{
   projectileShapeName = "add-ons/projectile_gravityrocket/rocketGravityProjectile.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::sentryGunCannon;
   radiusDamageType    = $DamageType::sentryGunCannon;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 60;
   verticalImpulse	  = 40;
   explosion           = sentryRocketExplosion;
   particleEmitter     = sentryRocketTrailEmitter;

   muzzleVelocity      = 80;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.4;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//sentry gun datablock (weapon image)
datablock ShapeBaseImageData(sentryCannonImage)
{
   shapeFile = "add-ons/weapon_sentry/sentryTank1.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryCannonProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 12.0;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]	= "activate";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateAllowImageChange[1]         = true;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 2.0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryRocketSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryCannonImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 2======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryGunCannon2",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket2> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket2> %1',0.75,1);
//projectile
datablock ProjectileData(sentryRocketProjectile)
{
   projectileShapeName = "add-ons/projectile_gravityrocket/rocketGravityProjectile.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::sentryGunCannon2;
   radiusDamageType    = $DamageType::sentryGunCannon2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 20;
   verticalImpulse	  = 10;
   explosion           = sentryRocket2Explosion;
   particleEmitter     = sentryRocketTrailEmitter;

   muzzleVelocity      = 120;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ShapeBaseImageData(sentryRocketImage)
{
   shapeFile = "add-ons/weapon_sentry/sentryRocket2.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryRocketProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.75;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 1.75;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryRocketSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryRocketImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 3======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryGunCannon3",   '%1 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket3> %1',    '%2 <bitmap:add-ons/Weapon_Sentry/CI_s_rocket3> %1',0.75,1);
//projectile
datablock ProjectileData(sentryBigRocketProjectile)
{
   projectileShapeName = "add-ons/projectile_gravityrocket/rocketGravityProjectile.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::sentryGunCannon3;
   radiusDamageType    = $DamageType::sentryGunCannon3;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 10;
   verticalImpulse	  = 10;
   explosion           = sentryRocket3Explosion;
   particleEmitter     = sentryRocketTrailEmitter;

   muzzleVelocity      = 160;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ShapeBaseImageData(sentryBigRocketImage)
{
   shapeFile = "add-ons/weapon_sentry/sentryRocket3.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryBigRocketProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.75;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 1.5;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentryRocketSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryBigRocketImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}
